#include"generic.h"

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_KEYDOWN:
		
		switch(wParam)
		{
		case VK_ESCAPE:
			SendMessage(g_hWnd,WM_CLOSE,0,0);
			break;
		}

		break;

	case WM_DESTROY:

		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd,uMsg,wParam,lParam);
	}

	return 0;
}

BOOL InitApplication(HINSTANCE hInst)
{
	WNDCLASSEX wc;

	wc.cbSize		= sizeof(wc);
	wc.style		= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	= WndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInst;
	wc.hIcon		= LoadIcon(NULL,IDI_APPLICATION);
	wc.hCursor		= LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName= TITLE_STRING;
	wc.hIconSm		= NULL;

	if (!RegisterClassEx(&wc))
	{
		return FALSE;
	}

	g_hWnd = CreateWindow(
		TITLE_STRING,
		TITLE_STRING,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,0,
		CW_USEDEFAULT,0,
		NULL,NULL,hInst,NULL);

	if (g_hWnd == NULL)
	{
		return FALSE;
	}

	ShowWindow(g_hWnd,SW_SHOW);
	UpdateWindow(g_hWnd);

	return TRUE;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR,int)
{
	MSG msg;

	if (hPrevInst)
	{	
		return FALSE;
	}

	if (!InitApplication(hInst))
	{
		return FALSE;
	}

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}